#include "gsRegistry.h"

gsRegistry::gsRegistry(configureFile &configFile)
{ unsigned int space;

	// Create string for volume key
	strcpy(volumeKey, "Software\\");
	space	= 255 - strlen(volumeKey);

	configFile.concat("CompanyName", volumeKey, space);
  strcat(volumeKey, "\\");
	configFile.concat("CollectionName", volumeKey, space);
  strcat(volumeKey, "\\");
	configFile.concat("CollectionVolume", volumeKey, space);
  strcat(volumeKey, "\\");
	configFile.concat("CollectionVersion", volumeKey, space);

	// Create string for collection key
	strcpy(collectKey, "Software\\");
	space	= 255 - strlen(collectKey);

	configFile.concat("CompanyName", collectKey, space);
  strcat(collectKey, "\\");
	configFile.concat("CollectionName", collectKey, space);
  strcat(collectKey, "\\");
	configFile.concat("CollectionVersion", collectKey, space);
}

bool gsRegistry::ensureKeysExist()
{	if (registry_ensureKeyExists(HKEY_LOCAL_MACHINE, this->collectKey) == false)
	{	return false;
  }
  if (registry_ensureKeyExists(HKEY_LOCAL_MACHINE, this->volumeKey) == false)
  {	return false;
  }
  return true;
}

bool gsRegistry::ensureKeyExists(HKEY base, const char *key)
{	return(registry_ensureKeyExists(base, key));
}

bool gsRegistry::storeKeyString(HKEY base, const char *path, const char *item, const char *string)
{	HKEY local;
	bool	reply;

  if (!registry_openkey(base, (char *) path, &local))
 	{	return false;
  }
  reply = registry_setstring(local, item, string);
  registry_closekey(local);
  return reply;
}

bool gsRegistry::collectionInstalled()
{	return registry_keyExists(HKEY_LOCAL_MACHINE, this->collectKey);
}

bool gsRegistry::volumeInstalled()
{	return registry_keyExists(HKEY_LOCAL_MACHINE, this->volumeKey);
}

char *gsRegistry::collectKeyId()
{	return this->collectKey;
}

char *gsRegistry::volumeKeyId()
{	return this->volumeKey;
}

char *gsRegistry::exeKeyId(char *exename)
{	char *reply	= new char[256];

	// Create string for exe path
	strcpy(reply, "Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\");
  strcat(reply, exename);
  return reply;
}

FilePath *gsRegistry::collectionPath()
{ char *path = NULL;
	FilePath *reply = NULL;
	HKEY key;

  if (registry_openkey(HKEY_LOCAL_MACHINE, this->collectKey, &key))
  {	if (registry_getstring(key, "library", &path))
  	{ // get leaf (\library.exe) and remove it to give a path
    	char *leaf;

    	leaf	= strrchr(path, '\\');
			if (leaf != NULL)
      { *leaf = '\0';
      }
      reply	= new FilePath(path);
      free(path);
    }
  	registry_closekey(key);
  }
  return reply;
}

